#charset "iso-8859-1"

#include <adv3.h>
#include <de_de.h>

// Die include Anweisungen mssen nicht manuell gesetzt werden, falls Ihr die Windows Workbench
// verwendet, passiert das ber die "Build Settings" (Alt+F7), dort mssen unter Compiler/Defines
// folgende zwei Zeilen stehen:

// LANGUAGE=de_de
// MESSAGESTYLE=neu

// Was hingegen "manuell" getan werden muss, ist das Charakterset mit #charset "iso-8859-1" auf
// das gebruchliche Latin-1 zu setzen, damit die deutschen Umlaute korrekt ausgegeben werden.

//Das Version Info Objekt vom Typ GameID speichert Informationen
//ber den Autor und die Beschreibung der Geschichte

versionInfo: GameID
    IFID = 'a31f618c-f29e-44fc-899b-4ad9e24ba582'
    name = 'Durch den Spiegel'
    byline = 'von Michael Baltes'
    htmlByline = 'by <a href="mailto:mail@michaelbaltes.com">
                  Michael Baltes</a>'
    version = '1.1'
    authorEmail = 'Michael Baltes <mail@michaelbaltes.com>'
    desc = 'Ein Beispiel von Gareth Rees'
    htmlDesc = 'Ein Beispiel von Gareth Rees'
;

gameMain: GameMainDef
    
//  Setzt den aktuellen Spielercharakter auf das Objekt 'me'
    initialPlayerChar = me
    
//  Funktion, die (falls vorhanden) ein Intro anzeigt oder weitere Deklarationen beinhalten kann
    showIntro() {
        "Drauen ist ein kalter Wintertag, aber im Spiegelhaus ist Sommer. Du musst nur fest daran glauben,
        dass es irgendeinen Weg gibt, hinein zu gelangen...<.p>";
        
        "<b>Durch den Spiegel</b>\nEin Interaktives Tutorial von Gareth Rees\n  
        bersetzt ins Deutsche und portiert nach Tads 3 von Michael Baltes, deutsche Bibliothek (<<libraryInfo.version>>)<.p>";

//      Wir starten unsere 'Daemons' in den beiden Kitten Objekten,
//      die spter erklrt werden, dazu wird in dem daemonID
//      Attribut das Daemon Objekt referenziert, um bei Bedarf darauf
//      zugreifen zu knnen
        
        whiteKitten.daemonID = new Daemon(whiteKitten, &daemon, 1);
        blackKitten.daemonID = new Daemon(blackKitten, &daemon, 1);
    }
  
;

// Der erste (und einzige) Raum, vom Typ Room (im Gegensatz zu OutdoorRoom), wovon das Objekt
// auch standardmig vier Wnde, den Boden und die Decke erbt. Die Template Schreibweise
// sieht folgendermaen aus:

// Objektname: abgeleitet von Klasse(n) 'name' 'destname' "desc"
// wobei name den in der Statuszeile
// angezeigten Text meint, destname hingegen den Ausgabenamen fr den Exitlister darstellt,
// bespielsweise kann der name 'Auf einem weiten Feld' sein, der destname hingegen sollte
// dann 'weit[^] Feld[-es]' sein, damit der Exitlister korrekt 'Mgliche Ausgnge
// sind Osten, zurck zu dem weiten Feld' ausgibt

startRoom: Room 'Salon' 'Salon[-s]'
    "Sanft wehen Schneeflocken gegen das Fenster. Drauen ist es sicher kalt und du bist froh,
    hier im Warmen und Trockenen zu sein. Der Salon spiegelt sich im groen Wandspiegel ber dem
    Kaminsims. Eine warme Feuerstelle, ein flauschiger Teppich und ein bequemer Sessel, in dem 
    du dich einrollen und ausruhen kannst, machen diesen Raum sehr komfortabel. "
    
    // hier sollen Aktionen abgefangen werden, die auf dem Kaminsims keinen Sinn machen
    // die roomBeforeAction() wird in dem Raumobjekt aufgerufen, in dem sich der Spielercharakter
    // momentan befindet, analog gibt es roomAfterAction()
    
    // gAction speichert die momentane Aktion und scheint eine Art globale Variable zu sein,
    // was aber so nicht ganz stimmt, denn die g... Objekte (wie gPlayerChar, gAction, gDobj, gIobj) 
    // sind Makros, die auf im libGlobal Objekt abgelegte Referenzen verweisen
    
    roomBeforeAction() {
        if (!gActionIn(Look,Examine,Enter,Board,GetOffOf,GetOutOf,Out,ThrowAt) 
            && gPlayerChar.isIn(mantelpiece) && !gDobj.isIn(mantelpiece) && gDobj != mirror) {
            "Von dem Kaminsims aus geht das nicht. ";
            
            // die exit Anweisung ist erforderlich, um die Aktion hier abzubrechen
            exit;
        }
    }
;

// Hidden ist eine sog. Mix-in-Klasse, beinhaltet also Zusatzfunktionen, die einem Objekt
// durch die Mehrfachvererbung weitere Mglichkeiten erffnen. Diese Mix-in-Klassen bentigen
// immer eine Hauptklasse (hier: Thing), aus welcher die Standardfunktionen abgeleitet werden

// Hidden versteckt ein Objekt anfangs, bis es schlielich mit der discover() Funktion ins 
// Spiel gebracht wird.

// Die Template Schreibweise fr Objekte sieht folgendermaen aus:

// Objektname: abgeleitet von Klasse(n) 'vokabular' 'name' "desc"
// wobei das Vokabular Abjektive (getrennt mit Leerzeichen), Substantive (getrennt mit /) und
// Pluralwrter (getrennt mit *) unterscheidet. Pluralwrter sind nur von Belang, wenn Gegenstnde
// aufgezhlt werden sollen, wie z.B. Bonbons aus einem Bonbonautomaten. 

// Auerdem gibt es noch
// "weakTokens", die in Klammern vor den Adjektiven stehen mssen. Der Autor kann damit entscheiden,
// ob der Spieler sich mit einem Adjektiv bereits auf das Objekt beziehen darf (x weies) oder
// wei ein weakToken sein soll, das alleine nicht gltig ist.

+ redQueen : Thing, Hidden 'flammend rot knigin' 'rot[^] Knigin'
    "Sie ist eine flammend rote Schachfigur. "
    isHer = true
;

// Das Schachbrett ist von Surface abgeleitet (man kann Dinge darauf ablegen, es aber nicht 
// selbst betreten

// Die initSpecialDesc Funktion gibt einen besonderen Text aus, sofern das Objekt noch nicht
// bewegt oder aufgehoben wurde

// die Funktion iobjFor(PutOn) wird von der "PutOnAction" im indirekten Objekt (welches auf
// den Gegenstand verweist, der abgelegt werden soll) aufgerufen und hier mit einer eigenen
// Meldung berschrieben.

// Die Struktur von Aktionen ist immer wie folgt:

// -- erst verify() {...} - hier sind logische und unlogische Aktionen fr die Anwendung 
//    sinnvoller impliziter Aktionen hinterlegt (ffnen ist bei geschlossenen Objekten sinnvoll etc.)

// -- dann check() {...}  - hier ist Platz fr eigene Abfragen, die aufgrund der Spiellogik die Aktion
//    zulassen oder verbieten, das Makro fr einen fehlgeschlagenen Versuch ist hier
//    failCheck('Du kannst die Kiste nicht ffnen, solange der grne Zwerg darauf sitzt. ');

// -- dann action() {...} - Hier wird die Aktion ausgefhrt. Das 'inherited' Schlagwort ruft die
//    Ausfhrung der Aktion in der Superklasse auf, das bedeutet wir geben hier eine eigene Meldung
//    mit dem mainAction('Meldung') Makro aus, lassen aber das Ablegen durch die Superklasse abhandeln,
//    und sparen uns damit code, der ja sowieso schon vorhanden ist

+ chessBoard : Surface 'schachbrett/brett' 'Schachbrett[-s]'
    "Mit dem Schachbrett mit wei-rotem Muster hast du gespielt. Die Figuren sind verschwunden, seit die 
    Ktzchen damit gespielt haben. "
    initSpecialDesc = "Ein Schachbrett liegt hier achtlos auf dem Boden. "
    
    iobjFor(PutOn) {
        action() {
            if (gDobj == redQueen)
                mainReport('Auf dem Schachbrett ist die rote Knigin nun Alleinherrscherin. ');
            inherited;
        }
    }   
;

// Fixture ist die Klasse fr unverrckbare Gegenstnde

+ hearth : Fixture 'feuerstelle/stelle/feuer[n]' 'Feuerstelle'
    isHer = true
;

// Der Teppich: hier ist eine eigene Implementierung der "LookUnderAction" erforderlich, damit der
// Spielercharakter die rote Knigin entdeckt. Die Funktionen sind bereits bekannt, hier wird jedoch
// der Teppich als direktes Objekt angesprochen (schau unter teppich), daher wird dobjFor(LookUnder)
// verwendet

+ rug : Platform, Fixture 'indisch arabisch flauschig teppich/vorleger' 'Teppich[-s]'
    "Er ist wunderschn und stammt aus einem fernen Land, vielleicht aus Indien oder Arabien, wo auch immer
    diese sich befinden mgen. "
    isHim = true
    
    dobjFor(LookUnder) {
        verify() {
            if (gPlayerChar.isIn(self)) {
                illogicalNow('Du versuchst vergeblich unter den Teppich zu schauen. Solange du selbst darauf stehst,
                    ist es zwecklos. ');
            }
        }
        
        // die discovered Flagge ist entweder true oder nil. Falls noch nicht entdeckt, wird die Knigin "sichtbar" gemacht
        // und mitgenommen. Das "chessPiece" ist nur dazu da, dass der Spieler die Figur der Knigin (wei oder rot)
        // als Vokabular ansprechen kann (das ist im Original auch so, der Spieler kann alle Figuren ansprechen und
        // erhlt dann die Meldung, dass die Ktzchen sie verzogen haben). Nach Entdeckung der roten Knigin wird das
        // Platzhalterobjekt nicht mehr bentigt, da wir davon ausgehen, dass der Spieler jetzt mit "Knigin" die
        // rote Knigin meint. Das Bewegen von Gegenstnden erledigt die Funktion moveInto(Ort) fr uns.
        
        action() {
            if(redQueen.discovered) 
                "Du findest sonst nichts unter dem Teppich. "; 
            else { 
                "Du hebst eine Teppichecke hoch, findest darunter die rote Knigin des Schachbretts und nimmst sie mit. "; 
                redQueen.discover();
                redQueen.moveInto(gPlayerChar);
                chessPiece.moveInto(nil);
            } 
        }
    }
    
    // Wir definieren eine eigene Meldung, falls der Spieler den Teppich nehmen will
    cannotTakeMsg = 'Der Teppich ist viel zu schwer und unhandlich. '   
;

// Der Sessel ist von der Chair Klasse abgeleitet und erbt von Heavy die Eigenschaft, nicht gesondert
// in der Raumbeschreibung erwhnt zu werden, sowie die Fhigkeit, nicht mitgenommen werden zu knnen.
// In der Beschreibung ist konditionaler Text enthalten. Die <<Klammern>> umschlieen eine abgekrzte
// wenn-dann Schreibweise, die, falls zutreffend, den string nach dem Fragezeichen ausgibt, falls nicht
// den string nach dem :

// myLoc ist ein eigenes Attribut, in dem wir eine Referenz auf den Ort des Sessels hinterlegen. Das kann
// entweder das Fenster oder der Kamin sein.

// Das dobjFor Makro kennen wir schon, neu ist das dobjFor(Pull) asDobjFor(Push) Makro, das die Aktion Pull
// auf Push umleitet. Tads kennt auderdem noch die Aktion MoveTo, also ein Schieben mit Richtungsangabe,
// das wir in diesem Zusammenhang eigens abhandeln und dem Spieler noch eine Rckmeldung geben, dass er den
// Sessel nur zum Fenster oder zur Feuerstelle und nicht etwa zur Decke schieben kann. Falls die Ktzchen
// nicht beide beschftigt (isMentioned Flagge) sind, ist das unbeschftigte dabei im Weg.

// Das stagingLocations Attribut legt hier fest, dass der Sessel sowohl vom Raum, als auch vom Kaminsims
// aus erreicht werden kann, falls sich der Sessel beim Sims befindet

+ armchair : Chair, Heavy 'lehnstuhl/sessel' 'Sessel[-s]'
    "Es ist ein riesiger Sessel, der perfekte Platz fr ein Ktzchen oder ein kleines Mdchen, um sich
    einzurollen und zu dsen. Er ist zu <<myLoc == hearth? 'der Feuerstelle' : 'dem Fenster'>> geschoben. "
    myLoc = window
    isHim = true
      
    dobjFor(Push) {
        verify() {}
        check() {
            if (gPlayerChar.isIn(self))
                tryImplicitAction(GetOffOf, self);
            if (!whiteKitten.isMentioned || !blackKitten.isMentioned) {
                local i;
                if (whiteKitten.isMentioned)
                    i = whiteKitten;
                else
                    i = blackKitten;
                failCheck('Du bist gerade dabei, den Sessel zu bewegen, da bemerkst du,
                    dass ' + i.derName + ' im Weg ist. Gut, dass du es noch gesehen hast,
                        sonst wre das arme Ding zerquetscht worden. ');
            }
        }
        action() {
            if (myLoc == hearth) {
                myLoc = window;
                "Du schiebst den Sessel zum Fenster. ";
            }
            else {
                myLoc = hearth;
                "Du schiebst den Sessel zur Feuerstelle. ";
            }
        }
    }
    dobjFor(Pull) asDobjFor(Push)
    
    dobjFor(MoveTo) {
        verify() {}
        check() {
            if (gIobj != hearth && gIobj != mantelpiece && gIobj != window)
                failCheck('Du kannst den Sessel nicht zu {dem iobj/ihm} schieben. ');
            if (gIobj == hearth && myLoc == hearth)
                failCheck('Der Sessel ist schon bei der Feuerstelle. ');
            if (gIobj == window && myLoc == window)
                failCheck('Der Sessel ist schon beim Fenster. ');
        }
        action() {
            if (myLoc == hearth || myLoc == mantelpiece) {
                myLoc = window;
                "Du schiebst den Sessel zum Fenster. ";
            }
            else {
                myLoc = hearth;
                "Du schiebst den Sessel zur Feuerstelle. ";
            }
        }
    }
    stagingLocations = ( armchair.myLoc == hearth ? [mantelpiece,self.location] : [self.location] )
;

// Der Kaminsims: Das Betreten der "Platform" kann nur vom Sessel aus erfolgen, also fragen wir die
// verschiedenen Mglichkeiten in der check() Routine ab. Er kann vom Sessel und vom Raum aus erreicht
// werden, wie in dem stagingLocations Attribut festgelegt

+ mantelpiece : Platform, Fixture 'sims/kaminsims' 'Kaminsims'
    "Vom Boden aus ist es hher gelegen als dein Kopf, aber doch breit und stabil genug,
    um dich zu tragen. "
    isHim = true
    
    dobjFor(Board) {
        check() {
            if (!gPlayerChar.isIn(armchair)) {
                failCheck('Du kannst den Kaminsims von hier unten nicht erreichen. ');
            }
            else if (armchair.myLoc != hearth) {
                failCheck('Der Sessel ist zu weit vom Kaminsims entfernt. ');
            }
            else if (gPlayerChar.posture != standing) {
                failCheck('fast kannst du den Kaminsims erreichen, wenn du dich nur etwas grer
                    machen knntest! ');
            }
        }
    } 
    stagingLocations = [armchair,self.location]
;

// Der Spiegel verwendet "substitution strings" in der Aktionsbeschreibung. Diese sind immer in {}
// Klammern angegeben. {den dobj/ihn} gibt das aktuelle direkte Objekt im Akkusativ aus. {sieht}
// ersetzt eine passende Verbform von sehen fr das aktuelle Satzsubjekt. Daneben gibt es noch eine
// einfach {...|...} Syntax, die den ersten Teil der Klammer ausgibt, falls die Erzhlform das Prsens
// ist, den zweiten Teil bei Vergangenheit. Somit knnte bei konsequenter Anwendung dieser Ersetzungen
// sogar der Spieler die Wahl der Person und der Zeitform der Erzhlung erhalten.

// actionDobjFeel() {...} kennen wir noch nicht, es ist ein Makro fr dobjFor(Feel) action() {...}
// Der Rest iat altbekannt, nur canObjReachSelf(obj) { return obj.isIn(mantelpiece); } ist eine Funktion
// der Mix-in-Klasse OutOfReach, die den Spiegel nur vom Kaminsims aus erreichbar macht.

+ mirror : OutOfReach, Fixture 'spiegel' 'Spiegel[-s]'
    "<<if gPlayerChar.isIn(mantelpiece)>>Seltsamerweise scheint sich das Glas in einen hellen, silbrigen
    Nebel zu verwandeln<<else if (gPlayerChar.isIn(armchair))>>Im Spiegel siehst du den Spiegel-Salon, der
    fast wie dieser Raum aussieht, nur spiegelverkehrt. Aber in den Ecken des Spiegels, die du nicht richtig 
    sehen kannst, schaut die Welt des Spiegelhauses ganz anders aus als deine Welt<<else>>Im Spiegel erkennst
    du die Decke des Salons des Spiegelhauses. Sie hnelt der Decke dieses Raumes. "
    iobjFor(LookAtIn) {
        verify() {
            if (gDobj == hearth || gDobj == mirror || (!gPlayerChar.isIn(mantelpiece) && !gPlayerChar.isIn(armchair)))
                illogicalNow('Du kannst {den dobj/ihn} nicht im Spiegel sehen. ');
        }
        action() {
            "<<if (gDobj == gPlayerChar)>>Alice sieht<<else>>{Der dobj/er} {sieht}<<end>> <<gPlayerChar.isIn(mantelpiece) ? 'trb und unscharf aus' : 'wie echt aus,
                nur spiegelverkehrt'>>. ";
        }
    }
    dobjFor(LookIn) asDobjFor(Examine)
    actionDobjFeel() {
        "Deine Hand greift durch den silbrigen Nebel! ";
    }
    iobjFor(ThrowAt) {
        check() {
            failCheck('Du willst doch nicht sieben Jahre Unglck riskieren, oder? ');
        }
    }
    dobjFor(Board) {
        verify() {}
        check() {}
        action()  {
            "Deine Hand fasst durch den silbrigen Nebel, einen Moment spter folgt
            der Rest von dir und du betrittst eine neue Welt...";
            finishGameMsg(ftVictory, [finishOptionUndo]);
        }
    }
    dobjFor(Enter) asDobjFor(Board)
    canObjReachSelf(obj) { return obj.isIn(mantelpiece); }
    isHim = true
;

// Das Wollknuel kann ab- oder aufgewickelt sein, die entsprechende Aktion (Untangle)
// wird am Ende des Quellcodes definiert, die Flagge isTangled spiegelt den Zustand
// wider. Fr das "Abgewickeltsein" und "Aufgewickeltsein" definieren wir einen ThingState
// Objekt, zusammen mit dem passenden Vokabular. Der Zustand wird anhand der Flagge isTangled
// ermittelt mittels getState = ...

+ worsted : Thing 'fein blau wollknuel/knuel/wolle[f]' 'Wollknuel[-s]'
    "Es ist <<isTangled ? 'in einem verheerenden Zustand. All die Zeit des Aufwickelns
        war wohl umsonst' : 'ein Knuel aus feiner blauer Wolle, sorgsam aufgwickelt
            und fr das Stricken vorbereitet'>>. "
    initSpecialDesc = "Ein Wollknuel liegt hier auf dem Boden. "
    isTangled = nil
    allStates = [worstedTangled, worstedUntangled]
    getState = (isTangled ? worstedTangled : worstedUntangled)
    
    adjective = 'verwirrt' 'abgewickelt' 'aufgerollt' 'aufgewickelt'
    
    dobjFor(Untangle) {
        verify() {}
        check() {
            if (!isTangled)
                failCheck('Das Wollknuel ist schon ordentlich aufgewickelt. ');
        }
        action() {
            isTangled = nil;
            mainReport('Du wickelst das Wollknuel mhsam wieder auf. ');
        }
    }
    
;

// Die beiden ThingState Objekte mit dem Vokabular. Das doppelte ++ weist diese beiden
// Objekte dem vorhergehenden zu. Tads erlaubt hier eine weitreichende Hierarchie, 
// alternativ knnte diese Eigenschaft aber auch durch das "@" in der Template Schreibweise
// ersetzt werden, falls jemand die + Notation unbersichtlich findet

++ worstedTangled: ThingState 'verwirrt'
    stateTokens = ['verwirrt', 'abgewickelt']
;

++ worstedUntangled: ThingState 'aufgewickelt'
    stateTokens = ['aufgerollt', 'aufgewickelt']
;

// Die bereits oben erwhnten Platzhalterobjekte, hier getrennt in die Knigin und
// den Rest der Figuren. Die Klasse ist Unthing, also Sachen, die man ansprechen, nicht aber
// sehen oder berhren kann

+ chessPieces : Unthing '(wei) (rot) knig/springer/turm/lufer/bauer' 'Schachfiguren' 
    notHereMsg = 'Diese Schachfigur scheint zu fehlen. Verrckte Ktzchen! '
    isPlural = true
;

+ chessPiece : Unthing 'wei knigin' 'wei[^] Knigin'
    notHereMsg = chessPieces.notHereMsg
    isHer = true
;

// Das Fenster macht praktisch nichts, auer dass man durchschauen kann, denn das ffnen wird
// abgefangen

+ window : Openable, Fixture 'fenster' 'Fenster'
    "Drauen schneit es fest und du bist froh, hier im Warmen zu sein. "
    dobjFor(Open) {
        verify() {
            illogicalNow('Du willst dich doch nicht erklten, oder? Lass das Fenster besser zu. ');
        }
    }
    actionDobjLookThrough {
        "Drauen ist tiefer Winter. ";
    }
;

// Das Spielercharakter Objekt, in der Minimaldefinition. Mehr ist fr dieses Beispiel nicht ntig
+ me : Actor
;

// Wir legen fr die Ktzchen eine eigene Klasse an: Kitten
// Dabei spielen wir mit den beiden Objekten, das eine kann auf das andere ber das otherKitten
// Attribut zugreifen. Wir lassen zudem die beiden Ktzchen abwechselnd agieren, dies wird in
// der Flagge thisKittensTurn festgehalten. Die Routine checkTakeFromInventory wird berschrieben,
// damit wir den Ktzchen ihr Spielzeug auch wieder wegnehmen knnen.

// In diesem Fall habe ich mich dazu entschieden, den Ktzchen das Spielzeug als Inventar mitzugeben,
// womit das Ktzchen spielt kann also ber das Inventar abgefragt werden. In der Beschreibung wollen
// wir keine Auflistung des Inventars haben, da das etwas schrg klingt, daher wird
// contentsListedInExamine auf nil gesetzt.

// describeAction() ist eine eigene Routine fr die desc Funktion, die einen passenden Text ausgibt,
// fr die specialDesc Funktion verwenden wir und describeKitten(kitten). specialDesc funktoniert im
// Grunde wie initSpecialDesc, die Ausgabe wird aber ber die useSpecialDesc Flagge ein- oder ausgeschaltet

class Kitten : Actor 'katze[f]/ktzchen' 'Ktzchen[-s]'
    "Es ist <<einName>>, das <<describeAction()>> Ein ses kleines Ktzchen,
    viel ser als <<otherKitten.derName>>. "
    
    isMentioned = (self.contents != [])
    otherKitten = nil
    thisKittensTurn = nil
    contentsListedInExamine = nil
    checkTakeFromInventory(actor, obj) {}
    
    describeAction() {
        if (worsted.isIn(self))
            "mit dem Wollknuel spielt. ";
        else if (redQueen.isIn(self))
            "mit der roten Knigin spielt. ";
        else
            "mit dem anderen Ktzchen um den Stuhl herum tollt. ";
    }
    
    describeKitten(kitten) {
        if (!whiteKitten.isMentioned && !blackKitten.isMentioned && self == whiteKitten) {
            "Die beiden Ktzchen spielen bei dem Sessel. ";
        }
        else if (whiteKitten.isMentioned && blackKitten.isMentioned && self == whiteKitten) {
            say( (redQueen.isIn(kitten) ? '\^' + kitten.derName + ' spielt mit der roten Knigin '
                : kitten.derName + ' spielt mit dem Wollknuel ') + 'und ' + (redQueen.isIn(otherKitten) ? 
                    otherKitten.derName + ' spielt mit der roten Knigin. '
                : otherKitten.derName + ' spielt mit dem Wollknuel. ') );
        }
        else {
            if (isMentioned)
                say( (redQueen.isIn(kitten) ? '\^' + kitten.derName + ' spielt mit der roten Knigin '
                    : kitten.derName + ' spielt mit dem Wollknuel ') + 'und ' + otherKitten.derName +
                    ' spielt bei dem Sessel. ' );
        }
    }
    
    dobjFor(Take) {
        check() {
            if (otherKitten.isIn(gPlayerChar))
                failCheck('Du kannst nicht zwei Ktzchen auf einmal tragen. ');
        }
        action() {
            mainReport('Du hebst das Ktzchen auf deinen Arm. Was fr ein hbsches Ding! ');
            inherited;
        }
    }

    actionDobjDrop() {
        mainReport('Das Ktzchen springt von deinem Arm herunter und luft weg. ');
        inherited;
    }
    
    actionDobjFeel() {
        "Das Ktzchen reibt seinen Kopf an deinem Arm und schnurrt leise. ";
    }
    
    actionDobjKiss {
        "Du gibst dem Ktzchen einen Kuss auf die Nase. Es blickt dich treu an. ";
    }
    
    dobjFor(PutOn) asDobjFor(PutIn)
    actionDobjPutIn() {
        "Das Ktzchen springt von {dem dobj/ihm} herunter und trollt sich. ";
    }
    
    iobjFor(ThrowAt) {
        check() {
            if (gDobj == redQueen || gDobj == worsted) 
                replaceAction(GiveTo, gDobj, self);
        }
    }
    
    // Der Daemon, also quasi eine "Szene" die ablaufen soll:
    // die ID wird oben im gameMain Objekt gesetzt und dort wird auch das Objekt im
    // Ktzchen erzeugt. Falls die Chance von 1 zu 3 greift, gibt es einen passenden
    // Text und das andere Ktzchen ist nchstes Mal am Zug.
    
    daemonID = nil
    daemon() {
        
        if (rand(3) == 1 && thisKittensTurn) {
            thisKittensTurn = nil;
            otherKitten.thisKittensTurn = true;
            "\^<<self.derName>>";
            if (self.isIn(gPlayerChar))  
                "<<one of>> miaut wehleidig.
                <<or>> schnurrt leise vor sich hin.
                <<or>> schnurrt zufrieden.
                <<or>> reibt seine Ohren an dir.
                <<or>> springt aus deinem Arm und luft davon.<<self.moveIntoForTravel(startRoom)>>
                <<at random>> ";
            else if (redQueen.isIn(self))
                "<<one of>> haut mit der Pfote auf die rote Knigin.
                <<or>> hrt zu spielen auf und setzt sich wie unschuldig hin.
                <<or>> rollt die rote Knigin ber den Boden und jagt hinter ihr her.
                <<or>> hrt auf sich zu putzen.
                <<or>> beit die rote Knigin und schttelt sie, um sicher zu sein, dass sie tot ist.
                <<at random>> ";
            else if (worsted.isIn(self))
                "<<one of>> haut mit der Pfote auf das Wollknuel.
                <<or>> rollt das Wollknuel ber den Boden und jagt hinter ihm her.
                <<or>> ringt mit dem Wollknuel.
                <<or>> springt auf das Wollknuel und verheddert sich in den >Fden.
                <<or>> hrt zu spielen auf und kratzt sich an den Ohren.
                <<at random>> ";
            else {
                if (!otherKitten.isMentioned)
                    "<<one of>> jagt <<otherKitten.demName>> hinterher.
                    <<or>> springt auf <<otherKitten.denName>> und sie rollen sich auf dem Boden.
                    <<or>> haut <<otherKitten.denName>> mit seiner Pfote.
                    <<or>> rennt mit <<otherKitten.demName>> um den Sessel herum.
                    <<at random>> ";
                else
                    "<<one of>> jagt einem Staubkorn hinterher.
                    <<or>> rollt sich auf dem Boden.
                    <<or>> setzt sich auf und leckt sein Fell.
                    <<or>> reibt sich den Kopf an dem Sessel.
                    <<or>> jagt sich selbst.
                    <<at random>> ";
            }
        }
    }
    
    // Wir verwenden immer die spezielle Beschreibung fr die Ktzchen
    useSpecialDesc = true
;

// Unser weies Ktzchen kann nun mit Minimalaufwand definiert werden, da die Hauptarbeit bereits
// in der Klasse erledigt wurde. Wir geben dem Ktzchen noch jeweils ein GiveShowTopic mit, damit
// werden das Wollknuel und die rote Knigin behandelt. Sonst greift das DefaultGiveShowTopic
// mit der passenden Antwort.

+ whiteKitten : Kitten
    adjective = 'wei'
    name = 'wei[^] Ktzchen[-s]'
    otherKitten = blackKitten
    thisKittensTurn = true
    
    specialDesc = describeKitten(self)
    
;

++ GiveShowTopic @worsted
    topicResponse 
    {
        "Du wirfst das Wollknuel auf den Boden <<if whiteKitten.isIn(gPlayerChar)>> ,das Ktzchen springt 
        von deinem Arm und <<else>> und das Ktzchen <<end>>verwandelt das Knuel in Sekundenschnelle in ein Wirrwarr. ";
        whiteKitten.moveIntoForTravel(startRoom);
        worsted.moveInto(whiteKitten);
        worsted.isTangled = true;
    }
;

++ GiveShowTopic @redQueen
    topicResponse 
    {
        "Du wirfst die rote Knigin auf den Boden <<if whiteKitten.isIn(gPlayerChar)>> ,das Ktzchen springt 
        von deinem Arm und <<else>> und das Ktzchen <<end>>hetzt der Knigin hinterher. ";
        whiteKitten.moveIntoForTravel(startRoom);
        redQueen.moveInto(whiteKitten);
    }
;

++ DefaultGiveShowTopic
    "Das Ktzchen haut mit der Pfote auf {den dobj/ihn}. "
;

// Dasselbe gilt fr das schwarze Ktzchen

+ blackKitten : Kitten
    adjective = 'schwarz'
    name = 'schwarz[^] Ktzchen[-s]'
    otherKitten = whiteKitten
    thisKittensTurn = nil
    
    specialDesc = describeKitten(self)
;

++ GiveShowTopic @worsted
    topicResponse 
    {
        "Du wirfst das Wollknuel auf den Boden <<if blackKitten.isIn(gPlayerChar)>> ,das Ktzchen springt 
        von deinem Arm und <<else>> und das Ktzchen <<end>>verwandelt das Knuel in Sekundenschnelle in ein Wirrwarr. ";
        blackKitten.moveInto(startRoom);
        worsted.moveInto(blackKitten);
        worsted.isTangled = true;
    }
;

++ GiveShowTopic @redQueen
    topicResponse 
    {
        "Du wirfst die rote Knigin auf den Boden <<if blackKitten.isIn(gPlayerChar)>> ,das Ktzchen springt 
        von deinem Arm und <<else>> und das Ktzchen <<end>>hetzt der Knigin hinterher. ";
        blackKitten.moveInto(startRoom);
        redQueen.moveInto(blackKitten);
    }
;

++ DefaultGiveShowTopic
    "Das Ktzchen haut mit der Pfote auf {den dobj/ihn}. "
;

// Zuletzt folgen noch neue Verbdefinitionen.
// LookAtIn gilt fr den Spiegel, behandelt also den Fall, dass der Spieler etwas in dem Spiegel betrachten will
// Die Klasse ist TIAction, das heit nichts weiter als dass es ein direktes und indirektes Objekt gibt

DefineTIAction(LookAtIn)
;

// Die passende Verbschalone dazu

VerbRule(SchauAnIn)
    'schau' dobjList 'an' 'in' singleIobj
    | 'schau' dobjList 'in' singleIobj 'an'
    : LookAtInAction
    verbPhrase = 'anzuschauen/anschauen (was) (in dativ was)'
;

// Fr Untangle gibt es nur ein direktes Objekt, also wird TAction verwendet
// Wenn man mchte, kann man die drei Verbrules in einer zusammenfassen, jedoch gibt der parse-Debug 
// Befehl eine przisere Rckmeldung, wenn unterschiedliche rules verwendet. Die Flagge defaultForRecursion
// markiert die "Standardschablone" falls sie nicht gesetzt ist, nimmt der Parser die erstbeste fr die
// bekannten Nachfragen: Was willst du aufwickeln? usw.

DefineTAction(Untangle)
;

VerbRule(WickelAuf)
    'wickel' dobjList (|'auf')
    : UntangleAction
    verbPhrase = 'aufzuwickeln/aufwickeln (was)'
    defaultForRecursion = true
;

VerbRule(RollAuf)
    'roll' dobjList (|'auf')
    : UntangleAction
    verbPhrase = 'aufzurollen/aufrollen (was)'
;

VerbRule(Entwirr)
    'entwirr' dobjList 
    : UntangleAction
    verbPhrase = 'zu entwirren/entwirren (was)'
;

// Wir erweitern die FeelAction um das Verb Streichle (etwas) ...

VerbRule(Streichel)
    'streichl' dobjList
    | 'streichle' dobjList
    : FeelAction
    verbPhrase = 'zu streicheln/streicheln (was)'
;

// Zuallerletzt modifizieren wir Thing, die Basisklasse aller Tads Objekte:
// Wir bentigen neue Routinen fr unsere LookAtIn und Untangle Aktionen

modify Thing
    
    dobjFor(LookAtIn) {}
    iobjFor(LookAtIn) {
        verify() {
            illogicalNow('Welch seltsame Idee! ');
        }
    }
    
    dobjFor(Untangle) {
        preCond = [objHeld]
        verify() {
            illogicalNow('Auf welch seltsame Ideen du kommst! ');
        }
    }   
;

// Das wars. Ich hoffe, das Beispiel ist ziemlich selbsterklrend, falls Fragen auftauchen
// meldet Euch einfach unter www.ifzentrale.de
// Michael Baltes, September 2013
